<?php

define('FIFU_SPEEDUP_SIZES', serialize(array(75, 100, 150, 240, 320, 500, 640, 800, 1024, 1280, 1600)));

function fifu_is_from_speedup($url) {
    return strpos($url, "featuredimagefromurl.com") !== false;
}

function fifu_resize_speedup_image_size($size, $url) {
    return strpos($url, 'original') !== false ? str_replace('original', $size, $url) : preg_replace("/[0-9]+[.]webp/", $size . '.webp', $url);
}

function fifu_speedup_get_set($url) {
    $width = (int) explode('-', $url)[1];
    $set = '';
    $count = 0;
    foreach (unserialize(FIFU_SPEEDUP_SIZES) as $i) {
        if ($width < $i) {
            $set .= ', ' . $url . ' ' . $i . 'w';
            break;
        }
        $set .= (($count++ != 0) ? ', ' : '') . fifu_resize_speedup_image_size($i, $url) . ' ' . $i . 'w';
        if ($width == $i)
            break;
    }
    return $set;
}

function fifu_speedup_get_url($image, $size, $att_id) {
    // video-url
    $image_url = $video_url = null;
    $has_video = fifu_speedup_has_video_thumb($image[0]);

    // add sizes
    $aux = explode('/', $image[0])[4];
    $original_width = (int) explode('-', $aux)[1];
    $original_height = (int) explode('-', $aux)[2];

    if ($image[1] <= 1) {
        $image[1] = $original_width;
        $image[2] = $original_height;
    }

    $image = fifu_add_size($image, $size);

    // no height
    if (!$image[2])
        $image[2] = $image[1] * $original_height / $original_width;

    // crop
    if ($image[3] || $image[2]) {
        if ($has_video && $image[1] == 320 && $image[2] == 180) {
            $image[0] = $image[0] . "&resize=1280,720";
            $image[1] = 1280;
            $image[2] = 720;
        } else {
            $image[0] .= "?resize={$image[1]},{$image[2]}";
        }
    } else
        $image[0] .= "?theme-size={$image[1]},{$image[2]}";

    $image[0] = fifu_process_external_url($image[0], $att_id, $size);
    return $image;
}

function fifu_speedup_has_video_thumb($url) {
    return strpos($url, 'video-thumb') !== false;
}

